SET ECHO OFF
/*
  @tst_DF_2.sql  version 1.1
  Santiago Velilla 17 Mayo 2014
  Dpto. Informtica e Ingeniera de Sistemas, Universidad Zaragoza

  En este script se comprueba si los valores de la tabla especificada por el primer
  parmetro verifican, o no, la dependencia funcional X --> Y especificada a travs
  del resto de parmetros.  Los parmetros de llamada son:
  &1 representa el nombre de la tabla en la que hay que hacer la comprobacin
  &2 es el conjunto de atributos X que constituyen el determinante de la DF
  &3 es el conjunto de atributos Y que, supuestamente, dependen funcionalmente de X
  
  Para ello muestra el porcentaje de tuplas que no verifican la DF
  
  uso:
  @tst_DF_1.sql nombre_tabla atributos_X atributos_Y
*/
--------------------------------------------------------------------

PROMPT
PROMPT porcentaje mnimo de tuplas de la tabla &1 que no verifican la DF &2 --> &3
PROMPT

SELECT numFallos/tot_tuplas*100 "% fallos"
 FROM
  (SELECT sum(tuplas) numFallos
   FROM (SELECT sum(veces)-max(veces) tuplas
          FROM (SELECT &2, &3, count(*) veces FROM &1 GROUP BY &2, &3)
          GROUP BY &2)
  ), (SELECT count(*) tot_tuplas FROM &1);
